define("activesync/folder", [ "rdcommon/log", "../date", "../syncbase", "../allback", "../db/mail_rep", "activesync/codepages/AirSync", "activesync/codepages/AirSyncBase", "activesync/codepages/ItemEstimate", "activesync/codepages/Email", "activesync/codepages/ItemOperations", "safe-base64", "mimetypes", "module", "require", "exports" ], function(e, t, n, o, r, i, s, a, c, u, d, l, h, p, f) {
    function g() {
        v = i.Enums.FilterType, b = {
            auto: null,
            "1d": v.OneDayBack,
            "3d": v.ThreeDaysBack,
            "1w": v.OneWeekBack,
            "2w": v.TwoWeeksBack,
            "1m": v.OneMonthBack,
            all: v.NoFilter
        }, S = {
            0: "all messages",
            1: "one day",
            2: "three days",
            3: "one week",
            4: "two weeks",
            5: "one month"
        };
    }
    function m(e, t, n) {
        return function() {
            var o = Array.slice(arguments), r = o[e], i = this;
            p([ "wbxml", "addressparser", "../mailchew" ], function(e, s, a) {
                T || (T = e, w = s.parse.bind(s), E = a, g()), i._account.withConnection(r, function() {
                    t.apply(i, o);
                }, n);
            });
        };
    }
    function _(e, t, n) {
        this._account = e, this._storage = t, this._LOG = I.ActiveSyncFolderConn(this, n, t.folderId), 
        this.folderMeta = t.folderMeta, this.syncKey || (this.syncKey = "0");
    }
    function y(e, t, n) {
        this._account = e, this.folderStorage = t, this._LOG = I.ActiveSyncFolderSyncer(this, n, t.folderId), 
        this.folderConn = new _(e, t, this._LOG);
    }
    var v, b, S, T, w, E, A = 512, C = 50;
    _.prototype = {
        get syncKey() {
            return this.folderMeta.syncKey;
        },
        set syncKey(e) {
            return this.folderMeta.syncKey = e;
        },
        get serverId() {
            return this.folderMeta.serverId;
        },
        get filterType() {
            var e = this._account.accountDef.syncRange;
            if (b.hasOwnProperty(e)) {
                var t = b[e];
                return t ? t : this.folderMeta.filterType;
            }
            return console.warn("Got an invalid syncRange (" + e + ") using three days back instead"), 
            i.Enums.FilterType.ThreeDaysBack;
        },
        _getSyncKey: m(1, function(e, t) {
            var n = this, o = this._account, r = i.Tags, s = new T.Writer("1.3", 1, "UTF-8");
            s.stag(r.Sync).stag(r.Collections).stag(r.Collection), o.conn.currentVersion.lt("12.1") && s.tag(r.Class, "Email"), 
            s.tag(r.SyncKey, "0").tag(r.CollectionId, this.serverId).stag(r.Options).tag(r.FilterType, e).etag().etag().etag().etag(), 
            o.conn.postCommand(s, function(e, i) {
                if (e) return console.error(e), o._reportErrorIfNecessary(e), t("unknown"), void 0;
                n.syncKey = "0";
                var s = new T.EventParser();
                s.addEventListener([ r.Sync, r.Collections, r.Collection, r.SyncKey ], function(e) {
                    n.syncKey = e.children[0].textContent;
                }), s.onerror = function() {}, s.run(i), "0" === n.syncKey ? (console.error("Unable to get sync key for folder"), 
                t("unknown")) : t();
            });
        }),
        _getItemEstimate: m(1, function(e, t) {
            var n = a.Tags, o = i.Tags, r = this._account, s = new T.Writer("1.3", 1, "UTF-8");
            s.stag(n.GetItemEstimate).stag(n.Collections).stag(n.Collection), this._account.conn.currentVersion.gte("14.0") ? s.tag(o.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).stag(o.Options).tag(o.FilterType, e).etag() : this._account.conn.currentVersion.gte("12.0") ? s.tag(n.CollectionId, this.serverId).tag(o.FilterType, e).tag(o.SyncKey, this.syncKey) : s.tag(n.Class, "Email").tag(o.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).tag(o.FilterType, e), 
            s.etag(n.Collection).etag(n.Collections).etag(n.GetItemEstimate), r.conn.postCommand(s, function(e, o) {
                if (e) return console.error(e), r._reportErrorIfNecessary(e), t("unknown"), void 0;
                var i, s, c = new T.EventParser(), u = [ n.GetItemEstimate, n.Response ];
                c.addEventListener(u.concat(n.Status), function(e) {
                    i = e.children[0].textContent;
                }), c.addEventListener(u.concat(n.Collection, n.Estimate), function(e) {
                    s = parseInt(e.children[0].textContent, 10);
                });
                try {
                    c.run(o);
                } catch (d) {
                    return console.error("Error parsing GetItemEstimate response", d, "\n", d.stack), 
                    t("unknown"), void 0;
                }
                i !== a.Enums.Status.Success ? (console.error("Error getting item estimate:", i), 
                t("unknown")) : t(null, s);
            });
        }),
        _inferFilterType: m(0, function(e) {
            var t = this, n = i.Enums.FilterType, o = function(o, r) {
                t._getSyncKey(o, function(i) {
                    return i ? (e("unknown"), void 0) : (t._getItemEstimate(o, function(t, o) {
                        return t ? (e(null, n.ThreeDaysBack), void 0) : (r(o), void 0);
                    }), void 0);
                });
            };
            o(n.TwoWeeksBack, function(r) {
                var i, s = r / 14;
                if (0 > r) i = n.ThreeDaysBack; else if (s >= C) i = n.OneDayBack; else if (3 * s >= C) i = n.ThreeDaysBack; else if (7 * s >= C) i = n.OneWeekBack; else if (14 * s >= C) i = n.TwoWeeksBack; else {
                    if (!(30 * s >= C)) return o(n.NoFilter, function(o) {
                        var r;
                        o > C ? (r = n.OneMonthBack, t.syncKey = "0") : r = n.NoFilter, t._LOG.inferFilterType(r), 
                        e(null, r);
                    }), void 0;
                    i = n.OneMonthBack;
                }
                i !== n.TwoWeeksBack && (t.syncKey = "0"), t._LOG.inferFilterType(i), e(null, i);
            });
        }),
        _enumerateFolderChanges: m(0, function(e, t) {
            var n = this, o = this._storage;
            if (!this.filterType) return this._inferFilterType(function(o, r) {
                return o ? (e("unknown"), void 0) : (console.log("We want a filter of", S[r]), n.folderMeta.filterType = r, 
                n._enumerateFolderChanges(e, t), void 0);
            }), void 0;
            if ("0" === this.syncKey) return this._getSyncKey(this.filterType, function(o) {
                return o ? (e("aborted"), void 0) : (n._enumerateFolderChanges(e, t), void 0);
            }), void 0;
            var r = i.Tags, a = i.Enums;
            s.Tags, s.Enums;
            var c;
            0 === this._account._syncsInProgress++ && this._account._lastSyncKey === this.syncKey && this._account._lastSyncFilterType === this.filterType && this._account._lastSyncResponseWasEmpty ? c = r.Sync : (c = new T.Writer("1.3", 1, "UTF-8"), 
            c.stag(r.Sync).stag(r.Collections).stag(r.Collection), this._account.conn.currentVersion.lt("12.1") && c.tag(r.Class, "Email"), 
            c.tag(r.SyncKey, this.syncKey).tag(r.CollectionId, this.serverId).tag(r.GetChanges).stag(r.Options).tag(r.FilterType, this.filterType), 
            this._account.conn.currentVersion.lte("12.0") && c.tag(r.MIMESupport, a.MIMESupport.Never).tag(r.Truncation, a.MIMETruncation.TruncateAll), 
            c.etag().etag().etag().etag()), this._account.conn.postCommand(c, function(i, s) {
                var c, u = [], d = [], l = [], h = !1;
                if (n._account._syncsInProgress--, i) return console.error("Error syncing folder:", i), 
                n._account._reportErrorIfNecessary(i), e("aborted"), void 0;
                if (n._account._lastSyncKey = n.syncKey, n._account._lastSyncFilterType = n.filterType, 
                !s) return console.log("Sync completed with empty response"), n._account._lastSyncResponseWasEmpty = !0, 
                e(null, u, d, l), void 0;
                n._account._lastSyncResponseWasEmpty = !1;
                var p = new T.EventParser(), f = [ r.Sync, r.Collections, r.Collection ];
                p.addEventListener(f.concat(r.SyncKey), function(e) {
                    n.syncKey = e.children[0].textContent;
                }), p.addEventListener(f.concat(r.Status), function(e) {
                    c = e.children[0].textContent;
                }), p.addEventListener(f.concat(r.MoreAvailable), function() {
                    h = !0;
                }), p.addEventListener(f.concat(r.Commands, [ [ r.Add, r.Change ] ]), function(e) {
                    var t, i;
                    for (var s in Iterator(e.children)) {
                        var a = s[1];
                        switch (a.tag) {
                          case r.ServerId:
                            t = a.children[0].textContent;
                            break;

                          case r.ApplicationData:
                            try {
                                i = n._parseMessage(a, e.tag === r.Add, o);
                            } catch (c) {
                                return console.error("Failed to parse a message:", c, "\n", c.stack), void 0;
                            }
                        }
                    }
                    i.header.srvid = t;
                    var l = e.tag === r.Add ? u : d;
                    l.push(i);
                }), p.addEventListener(f.concat(r.Commands, [ [ r.Delete, r.SoftDelete ] ]), function(e) {
                    var t;
                    for (var n in Iterator(e.children)) {
                        var o = n[1];
                        switch (o.tag) {
                          case r.ServerId:
                            t = o.children[0].textContent;
                        }
                    }
                    l.push(t);
                });
                try {
                    p.run(s);
                } catch (g) {
                    return console.error("Error parsing Sync response:", g, "\n", g.stack), e("unknown"), 
                    void 0;
                }
                c === a.Status.Success ? (console.log("Sync completed: added " + u.length + ", changed " + d.length + ", deleted " + l.length), 
                e(null, u, d, l, h), h && n._enumerateFolderChanges(e, t)) : c === a.Status.InvalidSyncKey ? (console.warn("ActiveSync had a bad sync key"), 
                e("badkey")) : (console.error("Something went wrong during ActiveSync syncing and we got a status of " + c), 
                e("unknown"));
            }, null, null, function(e, n) {
                n || (n = Math.max(1e6, e)), t(.1 + .7 * e / n);
            });
        }, "aborted"),
        _parseMessage: function(e, t, n) {
            var o, i, a, u = c.Tags, d = s.Tags, h = s.Enums;
            if (t) {
                var p = n._issueNewHeaderId();
                o = {
                    id: p,
                    srvid: null,
                    suid: n.folderId + "/" + p,
                    guid: "",
                    author: null,
                    to: null,
                    cc: null,
                    bcc: null,
                    replyTo: null,
                    date: null,
                    flags: [],
                    hasAttachments: !1,
                    subject: null,
                    snippet: null
                }, i = {
                    date: null,
                    size: 0,
                    attachments: [],
                    relatedParts: [],
                    references: null,
                    bodyReps: null
                }, a = function(e, t) {
                    t && o.flags.push(e);
                };
            } else o = {
                flags: [],
                mergeInto: function(e) {
                    for (var t in Iterator(this.flags)) {
                        var n = t[1];
                        if (n[1]) e.flags.push(n[0]); else {
                            var o = e.flags.indexOf(n[0]);
                            -1 !== o && e.flags.splice(o, 1);
                        }
                    }
                    var r = [ "mergeInto", "suid", "srvid", "guid", "id", "flags" ];
                    for (var t in Iterator(this)) {
                        var i = t[0], s = t[1];
                        -1 === r.indexOf(i) && (e[i] = s);
                    }
                }
            }, i = {
                mergeInto: function(e) {
                    for (var t in Iterator(this)) {
                        var n = t[0], o = t[1];
                        "mergeInto" !== n && (e[n] = o);
                    }
                }
            }, a = function(e, t) {
                o.flags.push([ e, t ]);
            };
            var f, g;
            for (var m in Iterator(e.children)) {
                var _ = m[1], y = _.children.length ? _.children[0].textContent : null;
                switch (_.tag) {
                  case u.Subject:
                    o.subject = y;
                    break;

                  case u.From:
                    o.author = w(y)[0] || null;
                    break;

                  case u.To:
                    o.to = w(y);
                    break;

                  case u.Cc:
                    o.cc = w(y);
                    break;

                  case u.ReplyTo:
                    o.replyTo = w(y);
                    break;

                  case u.DateReceived:
                    i.date = o.date = new Date(y).valueOf();
                    break;

                  case u.Read:
                    a("\\Seen", "1" === y);
                    break;

                  case u.Flag:
                    for (var v in Iterator(_.children)) {
                        var b = v[1];
                        b.tag === u.Status && a("\\Flagged", "0" !== b.children[0].textContent);
                    }
                    break;

                  case d.Body:
                    for (var v in Iterator(_.children)) {
                        var b = v[1];
                        switch (b.tag) {
                          case d.Type:
                            var S = b.children[0].textContent;
                            S === h.Type.HTML ? f = "html" : (S !== h.Type.PlainText && console.warn("A message had a strange body type:", S), 
                            f = "plain");
                            break;

                          case d.EstimatedDataSize:
                            g = b.children[0].textContent;
                        }
                    }
                    break;

                  case u.BodySize:
                    f = "plain", g = y;
                    break;

                  case d.Attachments:
                  case u.Attachments:
                    for (var v in Iterator(_.children)) {
                        var T = v[1];
                        if (T.tag === d.Attachment || T.tag === u.Attachment) {
                            var E = {
                                name: null,
                                contentId: null,
                                type: null,
                                part: null,
                                encoding: null,
                                sizeEstimate: null,
                                file: null
                            }, A = !1;
                            for (var C in Iterator(T.children)) {
                                var I, O, x = C[1], M = x.children.length ? x.children[0].textContent : null;
                                switch (x.tag) {
                                  case d.DisplayName:
                                  case u.DisplayName:
                                    E.name = M, I = E.name.lastIndexOf("."), O = I > 0 ? E.name.substring(I + 1).toLowerCase() : "", 
                                    E.type = l.detectMimeType(O);
                                    break;

                                  case d.FileReference:
                                  case u.AttName:
                                    E.part = M;
                                    break;

                                  case d.EstimatedDataSize:
                                  case u.AttSize:
                                    E.sizeEstimate = parseInt(M, 10);
                                    break;

                                  case d.ContentId:
                                    E.contentId = M;
                                    break;

                                  case d.IsInline:
                                    A = "1" === M;
                                    break;

                                  case d.FileReference:
                                  case u.Att0Id:
                                    E.part = x.children[0].textContent;
                                }
                            }
                            A ? i.relatedParts.push(r.makeAttachmentPart(E)) : i.attachments.push(r.makeAttachmentPart(E));
                        }
                    }
                    o.hasAttachments = i.attachments.length > 0;
                }
            }
            return t ? (i.bodyReps = [ r.makeBodyPart({
                type: f,
                sizeEstimate: g,
                amountDownloaded: 0,
                isDownloaded: !1
            }) ], {
                header: r.makeHeaderInfo(o),
                body: r.makeBodyInfo(i)
            }) : {
                header: o,
                body: i
            };
        },
        downloadBodies: function(e, t, n) {
            if (this._account.conn.currentVersion.lt("12.0")) return this._syncBodies(e, n);
            for (var r = 0, i = o.latch(), s = 0; s < e.length; s++) {
                var a = e[s];
                a && null === a.snippet && (r++, this.downloadBodyReps(a, t, i.defer(a.suid)));
            }
            i.then(function(e) {
                n(o.extractErrFromCallbackArgs(e), r);
            });
        },
        downloadBodyReps: m(1, function(e, t, n) {
            var o = this, r = this._account;
            if (r.conn.currentVersion.lt("12.0")) return this._syncBodies([ e ], n);
            "function" == typeof t && (n = t, t = null), t = t || {};
            var a = u.Tags, c = u.Enums, d = i.Tags;
            i.Enums;
            var l = s.Tags, h = s.Enums.Type, p = function(i) {
                if (!i) return n("unknown");
                var s, u = i.bodyReps[0], p = "html" === u.type ? h.HTML : h.PlainText;
                t.maximumBytesToFetch < u.sizeEstimate && (p = h.PlainText, s = A);
                var f = new T.Writer("1.3", 1, "UTF-8");
                f.stag(a.ItemOperations).stag(a.Fetch).tag(a.Store, "Mailbox").tag(d.CollectionId, o.serverId).tag(d.ServerId, e.srvid).stag(a.Options).stag(a.Schema).tag(l.Body).etag().stag(l.BodyPreference).tag(l.Type, p), 
                s && f.tag(l.TruncationSize, s), f.etag().etag().etag().etag(), r.conn.postCommand(f, function(t, u) {
                    if (t) return console.error(t), r._reportErrorIfNecessary(t), n("unknown"), void 0;
                    var d, h, p = new T.EventParser();
                    p.addEventListener([ a.ItemOperations, a.Status ], function(e) {
                        d = e.children[0].textContent;
                    }), p.addEventListener([ a.ItemOperations, a.Response, a.Fetch, a.Properties, l.Body, l.Data ], function(e) {
                        h = e.children[0].textContent;
                    });
                    try {
                        p.run(u);
                    } catch (f) {
                        return n("unknown");
                    }
                    return d !== c.Status.Success ? n("unknown") : (o._updateBody(e, i, h, !!s, n), 
                    void 0);
                });
            };
            this._storage.getMessageBody(e.suid, e.date, p);
        }),
        _syncBodies: function(e, t) {
            var n = i.Tags, r = i.Enums, s = c.Tags, a = this, u = this._account, d = new T.Writer("1.3", 1, "UTF-8");
            d.stag(n.Sync).stag(n.Collections).stag(n.Collection).tag(n.Class, "Email").tag(n.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).stag(n.Options).tag(n.MIMESupport, r.MIMESupport.Never).etag().stag(n.Commands);
            for (var l = 0; l < e.length; l++) d.stag(n.Fetch).tag(n.ServerId, e[l].srvid).etag();
            d.etag().etag().etag().etag(), u.conn.postCommand(d, function(i, c) {
                if (i) return console.error(i), u._reportErrorIfNecessary(i), t("unknown"), void 0;
                var d = o.latch(), l = 0, h = new T.EventParser(), p = [ n.Sync, n.Collections, n.Collection ];
                h.addEventListener(p.concat(n.SyncKey), function(e) {
                    a.syncKey = e.children[0].textContent;
                }), h.addEventListener(p.concat(n.Status), function(e) {
                    var t = e.children[0].textContent;
                    t !== r.Status.Success && d.defer("status")("unknown");
                }), h.addEventListener(p.concat(n.Responses, n.Fetch, n.ApplicationData, s.Body), function(t) {
                    var n = e[l++], o = t.children[0].textContent, r = d.defer(n.suid);
                    a._storage.getMessageBody(n.suid, n.date, function(e) {
                        a._updateBody(n, e, o, !1, r);
                    });
                }), h.run(c), d.then(function(e) {
                    t(o.extractErrFromCallbackArgs(e));
                });
            });
        },
        _activeSyncHeaderIsSeen: function(e) {
            for (var t = 0; t < e.flags.length; t++) if ("\\Seen" === e.flags[t][0] && e.flags[t][1]) return !0;
            return !1;
        },
        _updateBody: function(e, t, n, r, i) {
            var s = t.bodyReps[0];
            n = n.replace(/\r/g, "");
            var a = r ? "plain" : s.type, c = E.processMessageContent(n, a, !r, !0, this._LOG);
            e.snippet = c.snippet, s.isDownloaded = !r, s.amountDownloaded = n.length, r || (s.content = c.content);
            var u = {
                changeDetails: {
                    bodyReps: [ 0 ]
                }
            }, d = o.latch();
            this._storage.updateMessageHeader(e.date, e.id, !1, e, t, d.defer("header")), this._storage.updateMessageBody(e, t, {}, u, d.defer("body")), 
            d.then(i.bind(null, null, t, !1));
        },
        sync: m(1, function(e, t, r) {
            var i = this, s = 0, a = 0, c = 0;
            this._LOG.sync_begin(null, null, null);
            var u = this;
            this._enumerateFolderChanges(function(r, d, l, h, p) {
                var f = i._storage;
                if ("badkey" === r) return i._account._recreateFolder(f.folderId, function() {
                    i._storage = null, i._LOG.sync_end(null, null, null);
                }), void 0;
                if (r) return i._LOG.sync_end(null, null, null), t(r), void 0;
                var g = o.latch();
                for (var m in Iterator(d)) {
                    var _ = m[1];
                    f.hasMessageWithServerId(_.header.srvid) || (f.addMessageHeader(_.header, _.body, g.defer()), 
                    f.addMessageBody(_.header, _.body, g.defer()), s++);
                }
                for (var m in Iterator(l)) {
                    var _ = m[1];
                    f.hasMessageWithServerId(_.header.srvid) && (f.updateMessageHeaderByServerId(_.header.srvid, !0, function(e, t) {
                        return !u._activeSyncHeaderIsSeen(t) && u._activeSyncHeaderIsSeen(e.header) ? f.folderMeta.unreadCount-- : u._activeSyncHeaderIsSeen(t) && !u._activeSyncHeaderIsSeen(e.header) && f.folderMeta.unreadCount++, 
                        e.header.mergeInto(t), !0;
                    }.bind(null, _), null, g.defer()), a++);
                }
                for (var m in Iterator(h)) {
                    var y = m[1];
                    f.hasMessageWithServerId(y) && (f.deleteMessageByServerId(y, g.defer()), c++);
                }
                if (!p) {
                    var v = s + a + c;
                    g.then(function() {
                        i._LOG.sync_end(s, a, c), f.markSyncRange(n.OLDEST_SYNC_DATE, e, "XXX", e), t(null, null, v);
                    });
                }
            }, r);
        }),
        performMutation: m(1, function(e, t) {
            var n = this, o = i.Tags, r = this._account, s = new T.Writer("1.3", 1, "UTF-8");
            s.stag(o.Sync).stag(o.Collections).stag(o.Collection), r.conn.currentVersion.lt("12.1") && s.tag(o.Class, "Email"), 
            s.tag(o.SyncKey, this.syncKey).tag(o.CollectionId, this.serverId).tag(o.DeletesAsMoves, "trash" === this.folderMeta.type ? "0" : "1").tag(o.GetChanges, "0").stag(o.Commands);
            try {
                e(s);
            } catch (a) {
                return console.error("Exception in performMutation callee:", a, "\n", a.stack), 
                t("unknown"), void 0;
            }
            s.etag(o.Commands).etag(o.Collection).etag(o.Collections).etag(o.Sync), r.conn.postCommand(s, function(e, s) {
                if (e) return console.error("postCommand error:", e), r._reportErrorIfNecessary(e), 
                t("unknown"), void 0;
                var a, c, u = new T.EventParser(), d = [ o.Sync, o.Collections, o.Collection ];
                u.addEventListener(d.concat(o.SyncKey), function(e) {
                    a = e.children[0].textContent;
                }), u.addEventListener(d.concat(o.Status), function(e) {
                    c = e.children[0].textContent;
                });
                try {
                    u.run(s);
                } catch (l) {
                    return console.error("Error parsing Sync response:", l, "\n", l.stack), t("unknown"), 
                    void 0;
                }
                c === i.Enums.Status.Success ? (n.syncKey = a, t && t(null)) : (console.error("Something went wrong during ActiveSync syncing and we got a status of " + c), 
                t("status:" + c));
            });
        }),
        downloadMessageAttachments: m(2, function(e, t, n) {
            var o = this, r = u.Tags, i = u.Enums.Status, a = s.Tags, c = new T.Writer("1.3", 1, "UTF-8");
            c.stag(r.ItemOperations);
            for (var l in Iterator(t)) {
                var h = l[1];
                c.stag(r.Fetch).tag(r.Store, "Mailbox").tag(a.FileReference, h.part).etag();
            }
            c.etag(), this._account.conn.postCommand(c, function(e, s) {
                if (e) return console.error("postCommand error:", e), o._account._reportErrorIfNecessary(e), 
                n("unknown"), void 0;
                var c, u = {}, l = new T.EventParser();
                l.addEventListener([ r.ItemOperations, r.Status ], function(e) {
                    c = e.children[0].textContent;
                }), l.addEventListener([ r.ItemOperations, r.Response, r.Fetch ], function(e) {
                    var t = null, n = {};
                    for (var o in Iterator(e.children)) {
                        var i = o[1];
                        switch (i.tag) {
                          case r.Status:
                            n.status = i.children[0].textContent;
                            break;

                          case a.FileReference:
                            t = i.children[0].textContent;
                            break;

                          case r.Properties:
                            var s = null, c = null;
                            for (var l in Iterator(i.children)) {
                                var h = l[1], p = h.children[0].textContent;
                                switch (h.tag) {
                                  case a.ContentType:
                                    s = p;
                                    break;

                                  case r.Data:
                                    c = d.decode(p);
                                }
                            }
                            s && c && (n.data = new Blob([ c ], {
                                type: s
                            }));
                        }
                        t && (u[t] = n);
                    }
                }), l.run(s);
                var h = c !== i.Success ? "unknown" : null, p = [];
                for (var f in Iterator(t)) {
                    var g = f[1];
                    u.hasOwnProperty(g.part) && u[g.part].status === i.Success ? p.push(u[g.part].data) : (h = "unknown", 
                    p.push(null));
                }
                n(h, p);
            });
        })
    }, f.ActiveSyncFolderSyncer = y, y.prototype = {
        get syncable() {
            return null !== this.folderConn.serverId;
        },
        get canGrowSync() {
            return !1;
        },
        initialSync: function(e, n, o, r, i) {
            o("sync", !0), this.folderConn.sync(t.NOW(), this.onSyncCompleted.bind(this, r, !0), i);
        },
        refreshSync: function(e, n, o, r, i, s, a) {
            this.folderConn.sync(t.NOW(), this.onSyncCompleted.bind(this, s, !1), a);
        },
        growSync: function() {
            return !1;
        },
        onSyncCompleted: function(e, t, o, r, i) {
            var s = this.folderStorage;
            console.log("Sync Completed!", i, "messages synced"), o || s.markSyncedToDawnOfTime(), 
            this._account.__checkpointSyncCompleted(function() {
                o ? e(o) : t ? (s._curSyncSlice.ignoreHeaders = !1, s._curSyncSlice.waitingOnData = "db", 
                s.getMessagesInImapDateRange(0, null, n.INITIAL_FILL_SIZE, n.INITIAL_FILL_SIZE, s.onFetchDBHeaders.bind(s, s._curSyncSlice, !1, e, null))) : e(o);
            });
        },
        allConsumersDead: function() {},
        shutdown: function() {
            this.folderConn.shutdown(), this._LOG.__die();
        }
    };
    var I = f.LOGFAB = e.register(h, {
        ActiveSyncFolderConn: {
            type: e.CONNECTION,
            subtype: e.CLIENT,
            events: {
                inferFilterType: {
                    filterType: !1
                }
            },
            asyncJobs: {
                sync: {
                    newMessages: !0,
                    changedMessages: !0,
                    deletedMessages: !0
                }
            },
            errors: {
                htmlParseError: {
                    ex: e.EXCEPTION
                },
                htmlSnippetError: {
                    ex: e.EXCEPTION
                },
                textChewError: {
                    ex: e.EXCEPTION
                },
                textSnippetError: {
                    ex: e.EXCEPTION
                }
            }
        },
        ActiveSyncFolderSyncer: {
            type: e.DATABASE,
            events: {}
        }
    });
}), define("activesync/jobs", [ "rdcommon/log", "mix", "../jobmixins", "../drafts/jobs", "activesync/codepages/AirSync", "activesync/codepages/Email", "activesync/codepages/Move", "module", "require", "exports" ], function(e, t, n, o, r, i, s, a, c, u) {
    function d(e, t, n) {
        return function() {
            var o = Array.slice(arguments), r = o[e], i = this;
            c([ "wbxml" ], function(e) {
                h || (h = e), i.account.withConnection(r, function() {
                    t.apply(i, o);
                }, n);
            });
        };
    }
    function l(e, t, n) {
        this.account = e, this.resilientServerIds = !0, this._heldMutexReleasers = [], this._LOG = p.ActiveSyncJobDriver(this, n, this.account.id), 
        this._state = t, t.hasOwnProperty("suidToServerId") || (t.suidToServerId = {}, t.moveMap = {}), 
        this._stateDelta = {
            serverIdMap: null,
            moveMap: null
        };
    }
    var h;
    u.ActiveSyncJobDriver = l, l.prototype = {
        postJobCleanup: n.postJobCleanup,
        allJobsDone: n.allJobsDone,
        _accessFolderForMutation: function(e, t, n, o, r) {
            var i = this.account.getFolderStorageForFolderId(e), s = this;
            i.runMutexed(r, function(e) {
                s._heldMutexReleasers.push(e);
                var o = i.folderSyncer;
                if (t) s.account.withConnection(n, function() {
                    try {
                        n(o.folderConn, i);
                    } catch (e) {
                        s._LOG.callbackErr(e);
                    }
                }); else try {
                    n(o.folderConn, i);
                } catch (r) {
                    s._LOG.callbackErr(r);
                }
            });
        },
        _partitionAndAccessFoldersSequentially: n._partitionAndAccessFoldersSequentially,
        local_do_modtags: n.local_do_modtags,
        do_modtags: d(1, function(e, t, n) {
            function o(e) {
                return s && -1 !== s.indexOf(e) ? !0 : a && -1 !== a.indexOf(e) ? !1 : void 0;
            }
            var s = n ? e.removeTags : e.addTags, a = n ? e.addTags : e.removeTags, c = o("\\Seen"), u = o("\\Flagged"), d = r.Tags, l = i.Tags, h = null;
            this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, n, o, r) {
                return n = n.filter(function(e) {
                    return !!e;
                }), n.length ? (e.performMutation(function(e) {
                    for (var t = 0; t < n.length; t++) e.stag(d.Change).tag(d.ServerId, n[t]).stag(d.ApplicationData), 
                    void 0 !== c && e.tag(l.Read, c ? "1" : "0"), void 0 !== u && e.stag(l.Flag).tag(l.Status, u ? "2" : "0").etag(), 
                    e.etag(d.ApplicationData).etag(d.Change);
                }, function(e) {
                    e && (h = e), r();
                }), void 0) : (r(), void 0);
            }, function() {
                t(h);
            }, function() {
                h = "aborted-retry";
            }, n, "modtags");
        }),
        check_modtags: function(e, t) {
            t(null, "idempotent");
        },
        local_undo_modtags: n.local_undo_modtags,
        undo_modtags: function(e, t) {
            this.do_modtags(e, t, !0);
        },
        local_do_move: n.local_do_move,
        do_move: d(1, function(e, t) {
            var n = null, o = this.account, r = this.account.getFolderStorageForFolderId(e.targetFolder), i = s.Tags;
            this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, s, a, c) {
                if (s = s.filter(function(e) {
                    return !!e;
                }), !s.length) return c(), void 0;
                if (s = s.filter(function(e) {
                    return !!e;
                }), !s.length) return c(), void 0;
                var u = new h.Writer("1.3", 1, "UTF-8");
                u.stag(i.MoveItems);
                for (var d = 0; d < s.length; d++) u.stag(i.Move).tag(i.SrcMsgId, s[d]).tag(i.SrcFldId, t.folderMeta.serverId).tag(i.DstFldId, r.folderMeta.serverId).etag(i.Move);
                u.etag(i.MoveItems), o.conn.postCommand(u, function(e) {
                    e && (n = e, console.error("failure moving messages:", e)), c();
                });
            }, function() {
                t(n, null, !0);
            }, function() {
                n = "aborted-retry";
            }, !1, "move");
        }),
        check_move: function() {},
        local_undo_move: n.local_undo_move,
        undo_move: function() {},
        local_do_delete: n.local_do_delete,
        do_delete: d(1, function(e, t) {
            var n = null, o = r.Tags;
            i.Tags, this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, r, i, s) {
                return r = r.filter(function(e) {
                    return !!e;
                }), r.length ? (e.performMutation(function(e) {
                    for (var t = 0; t < r.length; t++) e.stag(o.Delete).tag(o.ServerId, r[t]).etag(o.Delete);
                }, function(e) {
                    e && (n = e, console.error("failure deleting messages:", e)), s();
                }), void 0) : (s(), void 0);
            }, function() {
                t(n, null, !0);
            }, function() {
                n = "aborted-retry";
            }, !1, "delete");
        }),
        check_delete: function(e, t) {
            t(null, "idempotent");
        },
        local_undo_delete: n.local_undo_delete,
        undo_delete: function(e, t) {
            t("moot");
        },
        local_do_syncFolderList: function(e, t) {
            t(null);
        },
        do_syncFolderList: d(1, function(e, t) {
            var n, o = this.account, r = o.getFirstFolderWithType("inbox");
            r && null === r.serverId && (n = o.getFolderStorageForFolderId(r.id)), o.syncFolderList(function(e) {
                e || (o.meta.lastFolderSyncAt = Date.now()), t(e ? "aborted-retry" : null, null, !e), 
                n && n.hasActiveSlices && (e || (console.log("Refreshing fake inbox"), n.resetAndRefreshActiveSlices()));
            });
        }, "aborted-retry"),
        check_syncFolderList: function(e, t) {
            t(null, "coherent-notyet");
        },
        local_undo_syncFolderList: function(e, t) {
            t("moot");
        },
        undo_syncFolderList: function(e, t) {
            t("moot");
        },
        local_do_downloadBodies: n.local_do_downloadBodies,
        do_downloadBodies: n.do_downloadBodies,
        check_downloadBodies: n.check_downloadBodies,
        local_do_downloadBodyReps: n.local_do_downloadBodyReps,
        do_downloadBodyReps: n.do_downloadBodyReps,
        check_downloadBodyReps: n.check_downloadBodyReps,
        local_do_download: n.local_do_download,
        do_download: n.do_download,
        check_download: n.check_download,
        local_undo_download: n.local_undo_download,
        undo_download: n.undo_download,
        local_do_sendOutboxMessages: n.local_do_sendOutboxMessages,
        do_sendOutboxMessages: n.do_sendOutboxMessages,
        check_sendOutboxMessages: n.check_sendOutboxMessages,
        local_undo_sendOutboxMessages: n.local_undo_sendOutboxMessages,
        undo_sendOutboxMessages: n.undo_sendOutboxMessages,
        local_do_setOutboxSyncEnabled: n.local_do_setOutboxSyncEnabled,
        local_do_upgradeDB: n.local_do_upgradeDB,
        local_do_purgeExcessMessages: function(e, t) {
            t(null);
        },
        do_purgeExcessMessages: function(e, t) {
            t(null);
        },
        check_purgeExcessMessages: function() {
            return "idempotent";
        },
        local_undo_purgeExcessMessages: function(e, t) {
            t(null);
        },
        undo_purgeExcessMessages: function(e, t) {
            t(null);
        }
    }, t(l.prototype, o.draftsMixins);
    var p = u.LOGFAB = e.register(a, {
        ActiveSyncJobDriver: {
            type: e.DAEMON,
            events: {
                savedAttachment: {
                    storage: !0,
                    mimeType: !0,
                    size: !0
                },
                saveFailure: {
                    storage: !1,
                    mimeType: !1,
                    error: !1
                }
            },
            TEST_ONLY_events: {
                saveFailure: {
                    filename: !1
                }
            },
            errors: {
                callbackErr: {
                    ex: e.EXCEPTION
                }
            }
        }
    });
}), define("activesync/account", [ "rdcommon/log", "../a64", "../accountmixins", "../mailslice", "../searchfilter", "activesync/codepages/FolderHierarchy", "./folder", "./jobs", "../util", "../db/folder_info_rep", "module", "require", "exports" ], function(e, t, n, o, r, i, s, a, c, u, d, l, h) {
    function p(e, t, n) {
        return function() {
            var o = Array.slice(arguments), r = o[e], i = this;
            this.withConnection(r, function() {
                t.apply(i, o);
            }, n);
        };
    }
    function f(e, t, r, i, c, u) {
        this.universe = e, this.id = t.id, this.accountDef = t, t.connInfo.deviceId || (t.connInfo.deviceId = h.makeUniqueDeviceId()), 
        this._db = i, this._LOG = S.ActiveSyncAccount(this, u, this.id), c ? (this.conn = c, 
        this._attachLoggerToConnection(this.conn)) : this.conn = null, this.enabled = !0, 
        this.problems = [], this._alive = !0, this.identities = t.identities, this.folders = [], 
        this._folderStorages = {}, this._folderInfos = r, this._serverIdToFolderId = {}, 
        this._deadFolderIds = null, this._syncsInProgress = 0, this._lastSyncKey = null, 
        this._lastSyncResponseWasEmpty = !1, this.meta = r.$meta, this.mutations = r.$mutations, 
        this.tzOffset = 0;
        for (var d in r) if ("$" !== d[0]) {
            var l = r[d];
            this._folderStorages[d] = new o.FolderStorage(this, d, l, this._db, s.ActiveSyncFolderSyncer, this._LOG), 
            this._serverIdToFolderId[l.$meta.serverId] = d, this.folders.push(l.$meta);
        }
        this.folders.sort(function(e, t) {
            return e.path.localeCompare(t.path);
        }), this._jobDriver = new a.ActiveSyncJobDriver(this, this._folderInfos.$mutationState), 
        this.ensureEssentialOfflineFolders(), n.accountConstructorMixin.call(this, this, this);
    }
    var g, m, _, y = c.bsearchForInsert, v = i.Enums.Type, b = h.DEFAULT_TIMEOUT_MS = 3e4;
    h.makeUniqueDeviceId = function() {
        return Math.random().toString(36).substr(2);
    }, h.Account = h.ActiveSyncAccount = f, f.prototype = {
        type: "activesync",
        supportsServerFolders: !0,
        toString: function() {
            return "[ActiveSyncAccount: " + this.id + "]";
        },
        withConnection: function(e, t, n) {
            if (!g) return l([ "wbxml", "activesync/protocol", "activesync/codepages" ], function(o, r, i) {
                g = o, m = r, _ = i, this.withConnection(e, t, n);
            }.bind(this)), void 0;
            if (!this.conn) {
                var o = this.accountDef;
                this.conn = new m.Connection(o.connInfo.deviceId), this._attachLoggerToConnection(this.conn), 
                this.conn.open(o.connInfo.server, o.credentials.username, o.credentials.password), 
                this.conn.timeout = b;
            }
            this.conn.connected ? t() : this.conn.connect(function(o) {
                return o ? (this._reportErrorIfNecessary(o), this._isBadUserOrPassError(o) && !n && (n = "bad-user-or-pass"), 
                e(n || "unknown"), void 0) : (t(), void 0);
            }.bind(this));
        },
        _isBadUserOrPassError: function(e) {
            return e && e instanceof m.HttpError && 401 === e.status;
        },
        _reportErrorIfNecessary: function(e) {
            e && this._isBadUserOrPassError(e) && this.universe.__reportAccountProblem(this, "bad-user-or-pass", "incoming");
        },
        _attachLoggerToConnection: function(e) {
            var t = S.ActiveSyncConnection(e, this._LOG, Date.now() % 1e3);
            "safe" === t.logLevel ? e.onmessage = this._onmessage_safe.bind(this, t) : "dangerous" === t.logLevel && (e.onmessage = this._onmessage_dangerous.bind(this, t));
        },
        _onmessage_safe: function(e, t, n, o, r, i, s, a) {
            "options" === t ? e.options(n, o.status, a) : e.command(t, n, o.status);
        },
        _onmessage_dangerous: function(e, t, n, o, r, i, s, a) {
            if ("options" === t) e.options(n, o.status, a); else {
                var c, u;
                if (s) try {
                    var d = new g.Reader(new Uint8Array(s), _);
                    c = d.dump();
                } catch (l) {
                    c = "parse problem";
                }
                if (a) try {
                    u = a.dump(), a.rewind();
                } catch (l) {
                    u = "parse problem";
                }
                e.command(t, n, o.status, r, i, c, u);
            }
        },
        toBridgeWire: function() {
            return {
                id: this.accountDef.id,
                name: this.accountDef.name,
                path: this.accountDef.name,
                type: this.accountDef.type,
                defaultPriority: this.accountDef.defaultPriority,
                enabled: this.enabled,
                problems: this.problems,
                syncRange: this.accountDef.syncRange,
                syncInterval: this.accountDef.syncInterval,
                notifyOnNew: this.accountDef.notifyOnNew,
                playSoundOnSend: this.accountDef.playSoundOnSend,
                identities: this.identities,
                credentials: {
                    username: this.accountDef.credentials.username
                },
                servers: [ {
                    type: this.accountDef.type,
                    connInfo: this.accountDef.connInfo
                } ]
            };
        },
        toBridgeFolder: function() {
            return {
                id: this.accountDef.id,
                name: this.accountDef.name,
                path: this.accountDef.name,
                type: "account"
            };
        },
        get numActiveConns() {
            return 0;
        },
        checkAccount: function(e) {
            null != this.conn && (this.conn.connected && this.conn.disconnect(), this.conn = null), 
            this.withConnection(function(t) {
                e(t);
            }, function() {
                e();
            });
        },
        __checkpointSyncCompleted: function(e, t) {
            this.saveAccountState(null, e, t || "checkpointSync");
        },
        shutdown: function(e) {
            this._LOG.__die(), e && e();
        },
        accountDeleted: function() {
            this._alive = !1, this.shutdown();
        },
        sliceFolderMessages: function(e, t) {
            var n = this._folderStorages[e], r = new o.MailSlice(t, n, this._LOG);
            n.sliceOpenMostRecent(r);
        },
        searchFolderMessages: function(e, t, n, o) {
            var i = this._folderStorages[e], s = new r.SearchSlice(t, i, n, o, this._LOG);
            return i.sliceOpenSearch(s), s;
        },
        syncFolderList: p(0, function(e) {
            var t = this, n = _.FolderHierarchy.Tags, o = new g.Writer("1.3", 1, "UTF-8");
            o.stag(n.FolderSync).tag(n.SyncKey, this.meta.syncKey).etag(), this.conn.postCommand(o, function(o, r) {
                if (o) return t._reportErrorIfNecessary(o), e(o), void 0;
                var i = new g.EventParser(), s = [];
                i.addEventListener([ n.FolderSync, n.SyncKey ], function(e) {
                    t.meta.syncKey = e.children[0].textContent;
                }), i.addEventListener([ n.FolderSync, n.Changes, [ n.Add, n.Delete ] ], function(e) {
                    var o = {};
                    for (var r in Iterator(e.children)) {
                        var i = r[1];
                        o[i.localTagName] = i.children[0].textContent;
                    }
                    e.tag === n.Add ? t._addedFolder(o.ServerId, o.ParentId, o.DisplayName, o.Type) || s.push(o) : t._deletedFolder(o.ServerId);
                });
                try {
                    i.run(r);
                } catch (a) {
                    return console.error("Error parsing FolderSync response:", a, "\n", a.stack), e("unknown"), 
                    void 0;
                }
                for (;s.length; ) {
                    var c = [];
                    for (var u in Iterator(s)) {
                        var d = u[1];
                        t._addedFolder(d.ServerId, d.ParentId, d.DisplayName, d.Type) || c.push(d);
                    }
                    if (c.length === s.length) throw new Error("got some orphaned folders");
                    s = c;
                }
                t.ensureEssentialOnlineFolders(), t.normalizeFolderHierarchy(), console.log("Synced folder list"), 
                e && e(null);
            });
        }),
        _folderTypes: {
            1: "normal",
            2: "inbox",
            3: "drafts",
            4: "trash",
            5: "sent",
            6: "normal",
            12: "normal"
        },
        _addedFolder: function(e, n, r, i, a, c) {
            if (!(a || i in this._folderTypes)) return !0;
            var d = r, l = null, h = 0;
            if ("0" !== n) {
                if (l = this._serverIdToFolderId[n], void 0 === l) return null;
                var p = this._folderInfos[l];
                d = p.$meta.path + "/" + d, h = p.$meta.depth + 1;
            }
            if (i === v.DefaultInbox) {
                var f = this.getFirstFolderWithType("inbox");
                if (f) return delete this._serverIdToFolderId[f.serverId], this._serverIdToFolderId[e] = f.id, 
                f.serverId = e, f.name = r, f.path = d, f.depth = h, f;
            }
            var g = this.id + "/" + t.encodeInt(this.meta.nextFolderNum++), m = this._folderInfos[g] = {
                $meta: u.makeFolderMeta({
                    id: g,
                    serverId: e,
                    name: r,
                    type: a || this._folderTypes[i],
                    path: d,
                    parentId: l,
                    depth: h,
                    lastSyncedAt: 0,
                    syncKey: "0",
                    version: o.FOLDER_DB_VERSION
                }),
                $impl: {
                    nextId: 0,
                    nextHeaderBlock: 0,
                    nextBodyBlock: 0
                },
                accuracy: [],
                headerBlocks: [],
                bodyBlocks: [],
                serverIdHeaderBlockMapping: {}
            };
            console.log("Added folder " + r + " (" + g + ")"), this._folderStorages[g] = new o.FolderStorage(this, g, m, this._db, s.ActiveSyncFolderSyncer, this._LOG), 
            this._serverIdToFolderId[e] = g;
            var _ = m.$meta, b = y(this.folders, _, function(e, t) {
                return e.path.localeCompare(t.path);
            });
            return this.folders.splice(b, 0, _), c || this.universe.__notifyAddedFolder(this, _), 
            _;
        },
        _deletedFolder: function(e, t) {
            var n = this._serverIdToFolderId[e], o = this._folderInfos[n], r = o.$meta;
            console.log("Deleted folder " + r.name + " (" + n + ")"), delete this._serverIdToFolderId[e], 
            delete this._folderInfos[n], delete this._folderStorages[n];
            var i = this.folders.indexOf(r);
            this.folders.splice(i, 1), null === this._deadFolderIds && (this._deadFolderIds = []), 
            this._deadFolderIds.push(n), t || this.universe.__notifyRemovedFolder(this, r);
        },
        _recreateFolder: function(e, t) {
            this._LOG.recreateFolder(e);
            var n = this._folderInfos[e];
            n.$impl = {
                nextId: 0,
                nextHeaderBlock: 0,
                nextBodyBlock: 0
            }, n.accuracy = [], n.headerBlocks = [], n.bodyBlocks = [], n.serverIdHeaderBlockMapping = {}, 
            null === this._deadFolderIds && (this._deadFolderIds = []), this._deadFolderIds.push(e);
            var r = this;
            this.saveAccountState(null, function() {
                var i = new o.FolderStorage(r, e, n, r._db, s.ActiveSyncFolderSyncer, r._LOG);
                for (var a in Iterator(r._folderStorages[e]._slices)) {
                    var c = a[1];
                    c._storage = i, c.reset(), i.sliceOpenMostRecent(c);
                }
                r._folderStorages[e]._slices = [], r._folderStorages[e] = i, t(i);
            }, "recreateFolder");
        },
        createFolder: p(3, function(e, t, n, o) {
            var r = this, i = e ? this._folderInfos[e] : "0", s = _.FolderHierarchy.Tags, a = _.FolderHierarchy.Enums.Status, c = _.FolderHierarchy.Enums.Type.Mail, u = new g.Writer("1.3", 1, "UTF-8");
            u.stag(s.FolderCreate).tag(s.SyncKey, this.meta.syncKey).tag(s.ParentId, i).tag(s.DisplayName, t).tag(s.Type, c).etag(), 
            this.conn.postCommand(u, function(e, n) {
                r._reportErrorIfNecessary(e);
                var u, d, l = new g.EventParser();
                l.addEventListener([ s.FolderCreate, s.Status ], function(e) {
                    u = e.children[0].textContent;
                }), l.addEventListener([ s.FolderCreate, s.SyncKey ], function(e) {
                    r.meta.syncKey = e.children[0].textContent;
                }), l.addEventListener([ s.FolderCreate, s.ServerId ], function(e) {
                    d = e.children[0].textContent;
                });
                try {
                    l.run(n);
                } catch (h) {
                    return console.error("Error parsing FolderCreate response:", h, "\n", h.stack), 
                    o("unknown"), void 0;
                }
                if (u === a.Success) {
                    var p = r._addedFolder(d, i, t, c);
                    o(null, p);
                } else u === a.FolderExists ? o("already-exists") : o("unknown");
            });
        }),
        deleteFolder: p(1, function(e, t) {
            var n = this, o = this._folderInfos[e].$meta, r = _.FolderHierarchy.Tags, i = _.FolderHierarchy.Enums.Status;
            _.FolderHierarchy.Enums.Type.Mail;
            var s = new g.Writer("1.3", 1, "UTF-8");
            s.stag(r.FolderDelete).tag(r.SyncKey, this.meta.syncKey).tag(r.ServerId, o.serverId).etag(), 
            this.conn.postCommand(s, function(e, s) {
                n._reportErrorIfNecessary(e);
                var a, c = new g.EventParser();
                c.addEventListener([ r.FolderDelete, r.Status ], function(e) {
                    a = e.children[0].textContent;
                }), c.addEventListener([ r.FolderDelete, r.SyncKey ], function(e) {
                    n.meta.syncKey = e.children[0].textContent;
                });
                try {
                    c.run(s);
                } catch (u) {
                    return console.error("Error parsing FolderDelete response:", u, "\n", u.stack), 
                    t("unknown"), void 0;
                }
                a === i.Success ? (n._deletedFolder(o.serverId), t(null, o)) : t("unknown");
            });
        }),
        sendMessage: p(1, function(e, t) {
            var n = this;
            e.withMessageBlob({
                includeBcc: !0
            }, function(o) {
                if (this.conn.currentVersion.gte("14.0")) {
                    var r = _.ComposeMail.Tags, i = new g.Writer("1.3", 1, "UTF-8", null, "blob");
                    i.stag(r.SendMail).tag(r.ClientId, Date.now().toString() + "@mozgaia").tag(r.SaveInSentItems).stag(r.Mime).opaque(o).etag().etag(), 
                    this.conn.postCommand(i, function(e, o) {
                        return e ? (n._reportErrorIfNecessary(e), console.error(e), t("unknown"), void 0) : (null === o ? (console.log("Sent message successfully!"), 
                        t(null)) : (console.error("Error sending message. XML dump follows:\n" + o.dump()), 
                        t("unknown")), void 0);
                    }, null, null, function() {
                        e.renewSmartWakeLock("ActiveSync XHR Progress");
                    });
                } else this.conn.postData("SendMail", "message/rfc822", o, function(e) {
                    return e ? (n._reportErrorIfNecessary(e), console.error(e), t("unknown"), void 0) : (console.log("Sent message successfully!"), 
                    t(null), void 0);
                }, {
                    SaveInSent: "T"
                }, null, function() {
                    e.renewSmartWakeLock("ActiveSync XHR Progress");
                });
            }.bind(this));
        }),
        getFolderStorageForFolderId: function(e) {
            return this._folderStorages[e];
        },
        getFolderStorageForServerId: function(e) {
            return this._folderStorages[this._serverIdToFolderId[e]];
        },
        getFolderMetaForFolderId: function(e) {
            return this._folderInfos.hasOwnProperty(e) ? this._folderInfos[e].$meta : null;
        },
        ensureEssentialOfflineFolders: function() {
            [ {
                type: "inbox",
                displayName: "Inbox",
                typeNum: v.DefaultInbox
            }, {
                type: "outbox",
                displayName: "outbox",
                typeNum: v.Unknown
            }, {
                type: "localdrafts",
                displayName: "localdrafts",
                typeNum: v.Unknown
            } ].forEach(function(e) {
                this.getFirstFolderWithType(e.type) || this._addedFolder(null, "0", e.displayName, e.typeNum, e.type, !0);
            }, this);
        },
        ensureEssentialOnlineFolders: function(e) {
            e && e();
        },
        normalizeFolderHierarchy: n.normalizeFolderHierarchy,
        scheduleMessagePurge: function(e, t) {
            t && t();
        },
        upgradeFolderStoragesIfNeeded: n.upgradeFolderStoragesIfNeeded,
        runOp: n.runOp,
        getFirstFolderWithType: n.getFirstFolderWithType,
        getFolderByPath: n.getFolderByPath,
        saveAccountState: n.saveAccountState,
        runAfterSaves: n.runAfterSaves,
        allOperationsCompleted: function() {}
    };
    var S = h.LOGFAB = e.register(d, {
        ActiveSyncAccount: {
            type: e.ACCOUNT,
            events: {
                createFolder: {},
                deleteFolder: {},
                recreateFolder: {
                    id: !1
                },
                accountDeleted: {
                    where: !1
                }
            },
            asyncJobs: {
                runOp: {
                    mode: !0,
                    type: !0,
                    error: !0,
                    op: !1
                },
                saveAccountState: {
                    reason: !0,
                    folderSaveCount: !0
                }
            },
            errors: {
                opError: {
                    mode: !1,
                    type: !1,
                    ex: e.EXCEPTION
                }
            }
        },
        ActiveSyncConnection: {
            type: e.CONNECTION,
            events: {
                options: {
                    special: !1,
                    status: !1,
                    result: !1
                },
                command: {
                    name: !1,
                    special: !1,
                    status: !1
                }
            },
            TEST_ONLY_events: {
                options: {},
                command: {
                    params: !1,
                    extraHeaders: !1,
                    sent: !1,
                    response: !1
                }
            }
        }
    });
}), define("activesync/configurator", [ "rdcommon/log", "slog", "../accountcommon", "../a64", "./account", "../date", "tcp-socket", "require", "exports" ], function(e, t, n, o, r, i, s, a, c) {
    function u(e, t) {
        function n(e) {
            if (a) {
                var n = a;
                a = null;
                try {
                    n.close();
                } catch (o) {}
                t(e);
            }
        }
        var o = /^https:\/\/([^:\/]+)(?::(\d+))?/.exec(e);
        if (!o) return t(null), void 0;
        var r = o[2] ? parseInt(o[2], 10) : 443, i = o[1];
        console.log("checking", i, r, "for security problem");
        var a = s.open(i, r);
        a.onopen = function() {
            a.send(new TextEncoder("utf-8").encode("GET /images/logo.png HTTP/1.1\n\n"));
        }, a.onerror = function(e) {
            var t = null;
            e && "object" == typeof e && /^Security/.test(e.name) && (t = "bad-security"), n(t);
        }, a.ondata = function() {
            n(null);
        };
    }
    c.account = r, c.configurator = {
        timeout: 3e4,
        _getFullDetailsFromAutodiscover: function(e, n, o, r) {
            t.log("activesync.configurator.autodiscover:begin", {
                url: o
            }), e.raw_autodiscover(o, n.emailAddress, n.password, self.timeout, !1, function(n, i) {
                if (n) {
                    var s = "no-config-info", a = {};
                    return n instanceof e.HttpError ? 401 === n.status ? s = "bad-user-or-pass" : 403 === n.status ? s = "not-authorized" : a.status = n.status : n instanceof e.AutodiscoverDomainError && t.log("activesync.configurator.autodiscover.error", {
                        message: n.message
                    }), t.log("activesync.configurator.autodiscover:end", {
                        url: o,
                        err: s
                    }), r(s, null, a), void 0;
                }
                t.log("activesync.configurator.autodiscover:end", {
                    url: o,
                    server: i.mobileSyncServer.url
                });
                var c = {
                    type: "activesync",
                    displayName: i.user.name,
                    incoming: {
                        server: i.mobileSyncServer.url,
                        username: i.user.email
                    }
                };
                r(null, c, null);
            });
        },
        tryToCreateAccount: function(e, t, n, o, r) {
            a([ "activesync/protocol" ], function(i) {
                return n.incoming.autodiscoverEndpoint ? (this._getFullDetailsFromAutodiscover(i, t, n.incoming.autodiscoverEndpoint, function(n, s, a) {
                    return n ? (o(n, s, a), void 0) : (this._createAccountUsingFullInfo(e, t, s, o, i, r), 
                    void 0);
                }.bind(this)), void 0) : (this._createAccountUsingFullInfo(e, t, n, o, i, r), void 0);
            }.bind(this));
        },
        _createAccountUsingFullInfo: function(e, n, s, a, c) {
            t.log("activesync.configurator.create:begin", {
                server: s.incoming.server
            });
            var d = {
                username: s.incoming.username,
                password: n.password
            }, l = r.makeUniqueDeviceId(), h = this, p = new c.Connection(l);
            p.open(s.incoming.server, d.username, d.password), p.timeout = r.DEFAULT_TIMEOUT_MS, 
            p.connect(function(r) {
                if (r) {
                    var f, g = {
                        server: s.incoming.server
                    };
                    return r instanceof c.HttpError ? (401 === r.status ? f = "bad-user-or-pass" : 403 === r.status ? f = "not-authorized" : (f = "server-problem", 
                    g.status = r.status), t.log("activesync.configurator.create:end", {
                        server: s.incoming.server,
                        err: f
                    }), a(f, null, g), void 0) : (u(s.incoming.server, function(e) {
                        var t;
                        t = e ? "bad-security" : "unresponsive-server", a(t, null, g);
                    }), void 0);
                }
                var m = o.encodeInt(e.config.nextAccountNum++), _ = {
                    id: m,
                    name: n.accountName || n.emailAddress,
                    defaultPriority: i.NOW(),
                    type: "activesync",
                    syncRange: "auto",
                    syncInterval: n.syncInterval || 0,
                    notifyOnNew: n.hasOwnProperty("notifyOnNew") ? n.notifyOnNew : !0,
                    playSoundOnSend: n.hasOwnProperty("playSoundOnSend") ? n.playSoundOnSend : !0,
                    credentials: d,
                    connInfo: {
                        server: s.incoming.server,
                        deviceId: l
                    },
                    identities: [ {
                        id: m + "/" + o.encodeInt(e.config.nextIdentityNum++),
                        name: n.displayName || s.displayName,
                        address: n.emailAddress,
                        replyTo: null,
                        signature: null
                    } ]
                };
                t.log("activesync.configurator.create:end", {
                    server: s.incoming.server,
                    id: m
                }), h._loadAccount(e, _, p, function(e) {
                    a(null, e, null);
                });
            });
        },
        recreateAccount: function(e, t, i, s) {
            var a = i.def, c = {
                username: a.credentials.username,
                password: a.credentials.password
            }, u = o.encodeInt(e.config.nextAccountNum++), d = {
                id: u,
                name: a.name,
                type: "activesync",
                syncRange: a.syncRange,
                syncInterval: a.syncInterval || 0,
                notifyOnNew: a.hasOwnProperty("notifyOnNew") ? a.notifyOnNew : !0,
                playSoundOnSend: a.hasOwnProperty("playSoundOnSend") ? a.playSoundOnSend : !0,
                credentials: c,
                connInfo: {
                    server: a.connInfo.server,
                    deviceId: a.connInfo.deviceId || r.makeUniqueDeviceId()
                },
                identities: n.recreateIdentities(e, u, a.identities)
            };
            this._loadAccount(e, d, null, function(e) {
                s(null, e, null);
            });
        },
        _loadAccount: function(e, t, n, o) {
            var r = {
                $meta: {
                    nextFolderNum: 0,
                    nextMutationNum: 0,
                    lastFolderSyncAt: 0,
                    syncKey: "0"
                },
                $mutations: [],
                $mutationState: {}
            };
            e.saveAccountDef(t, r), e._loadAccount(t, r, n, o);
        }
    };
});