define([ "./deferred", "./testcontext", "./extransform", "require", "exports" ], function(e, t, n, r, o) {
    function s(e, t) {
        this._loggerStack = [], this._pendingActorsByLoggerType = {}, this._captureAllLoggersByType = {}, 
        this.envOptions = e || {}, this.caseBlackboard = {}, this.fileBlackboard = t, this.testDomainSeq = 0, 
        this._liveActors = null;
    }
    function i(e, t, n, r) {
        if (!e) throw new Error("No test definer provided!");
        this._testDefiner = e, this._exposeToTestOptions = n, this._fileBlackboard = {}, 
        this._resultsReporter = r, this._runtimeContext = null, this._superDebug = t, this._logBadThingsToLogger = null;
    }
    function a(e) {
        function t(e) {
            if (null != e && "object" == typeof e) {
                if (-1 !== n.indexOf(e)) return console.error("CYCLE with traversal", r), void 0;
                n.push(e), r.push(".");
                var o, s = r.length - 1;
                o = "toJSON" in e ? e.toJSON() : e;
                for (var i in o) if (o.hasOwnProperty(i)) {
                    var a = o[i];
                    r[s] = i, t(a);
                }
                n.pop(), r.pop();
            }
        }
        var n = [], r = [];
        t(e);
    }
    function u(e, r, o, s, i) {
        var a = {
            schema: t.LOGFAB._rawDefs,
            fileFailure: {
                fileName: e,
                moduleName: r,
                variant: o,
                exceptions: s.map(n.transformException)
            }
        };
        i(a);
    }
    function c(e) {
        return function(t) {
            e("##### LOGGEST-TEST-RUN-BEGIN #####");
            try {
                e(JSON.stringify(t));
            } catch (n) {
                console.error("JSON problem:", n.message, n.stack, n);
                try {
                    a(t.log);
                } catch (r) {
                    console.error("exx y", r);
                }
            }
            e("##### LOGGEST-TEST-RUN-END #####");
        };
    }
    var l = t.STEP_TIMEOUT_MS;
    s.prototype = {
        toString: function() {
            return "[TestRuntimeContext]";
        },
        toJSON: function() {
            return {
                type: "TestRuntimeContext"
            };
        },
        pushLogger: function(e) {
            this._loggerStack.push(e);
        },
        popLogger: function(e) {
            var t = this._loggerStack.lastIndexOf(e);
            -1 !== t && this._loggerStack.splice(t, 1);
        },
        reportPendingActor: function(e) {
            var t = e.__defName;
            this._pendingActorsByLoggerType.hasOwnProperty(t) ? this._pendingActorsByLoggerType[t].push(e) : this._pendingActorsByLoggerType[t] = [ e ];
        },
        captureAllLoggersByType: function(e, t) {
            t ? this._captureAllLoggersByType[e] = t : delete this._captureAllLoggersByType[e];
        },
        reportNewLogger: function(e, t) {
            var n = e.__defName;
            if (this._pendingActorsByLoggerType.hasOwnProperty(n) && this._pendingActorsByLoggerType[n].length) {
                var r = this._pendingActorsByLoggerType[n].shift();
                r.__attachToLogger(e);
            } else this._captureAllLoggersByType.hasOwnProperty(n) && "object" != typeof e._ident && (this._captureAllLoggersByType[n][e._ident] = e);
            return !t && this._loggerStack.length ? this._loggerStack[this._loggerStack.length - 1] : t;
        },
        reportActiveActorThisStep: function(e) {
            if (!e) throw new Error("You are passing in a null actor!");
            if (null === this._liveActors) throw new Error("We are not in a step!");
            e._activeForTestStep || (this._liveActors.push(e), e.__prepForTestStep(this));
        },
        peekLogger: function() {
            return this._loggerStack.length ? this._loggerStack[this._loggerStack.length - 1] : null;
        }
    }, o.TestDefinerRunner = i, i.prototype = {
        toString: function() {
            return "[TestDefinerRunner]";
        },
        toJSON: function() {
            return {
                type: "TestDefinerRunner"
            };
        },
        runTestStep: function(t) {
            function n() {
                for (var n = 0; n < i.length; n++) s = i[n], s._logger ? s.__failUnmetExpectations() : t.log.actorNeverGotLogger(s.__defName, s.__name), 
                s.__resetExpectations();
                p._runtimeContext._liveActors = null, e.getAllActiveDeferreds().forEach(function(e) {
                    t.log.unresolvedPromise(e);
                }), r && r(" :( timeout, fail"), t.log.timeout(), t.log.result("fail"), f.resolve(!1), 
                f = null;
            }
            const r = this._superDebug;
            r && r("====== Running Step: " + t.log._ident);
            var o, s;
            this._logBadThingsToLogger = t.log;
            var i = this._runtimeContext._liveActors = t.actors.concat();
            for (o = 0; o < t.actors.length; o++) s = t.actors[o], s.__prepForTestStep(this._runtimeContext);
            t.log.run_begin();
            var a = t.log.stepFunc(null, t.testFunc);
            if (a instanceof Error) return r && r(" :( encountered an error in the step func:", a), 
            t.log.run_end(), t.log.result("fail"), Promise.resolve(!1);
            r && r(" there are", i.length, "live actors this step", "up from", t.actors.length, "step-defined actors");
            var u = [], c = !0;
            for (o = 0; o < i.length; o++) {
                s = i[o];
                var g = s.__waitForExpectations();
                if (g.then) u.push(g), r && r(" actor", s.__defName, s.__name, "generated a promise"); else if (!g) {
                    if (r) {
                        var d;
                        d = s._expectNothing && (s._expectations.length || s._iExpectation) ? "expected nothing, got something" : s._expectationsMetSoFar ? "unsure" : "expectations not met after " + s._iExpectation, 
                        r(" :( waitVal synchronously resolved to false on " + s + " because: " + d);
                    }
                    c = !1;
                }
            }
            if (u.length) {
                var f = new e(), p = this, _ = setTimeout(function() {
                    p._superDebug && p._superDebug("!! timeout fired, deferred?", null !== f), f && n();
                }, t.timeoutMS || l);
                return this._superDebug && this._superDebug("waiting on", u.length, "promises"), 
                Promise.all(u).then(function h() {
                    if (p._superDebug && p._superDebug("!! all resolved, deferred?", null !== f), f) {
                        clearTimeout(_);
                        for (var h = !0, e = 0; e < i.length; e++) s = i[e], s.__resetExpectations() || (h = !1, 
                        r && r(" :( weird actor error on: " + s));
                        p._runtimeContext._liveActors = null, t.log.run_end(), t.log.result(h ? "pass" : "fail"), 
                        f.resolve(c), f = null;
                    }
                }, function() {
                    p._superDebug && p._superDebug("!! failed, deferred?", null !== f), f && (clearTimeout(_), 
                    n());
                }), f.promise;
            }
            for (t.log.run_end(), t.log.result(c ? "pass" : "fail"), o = 0; o < i.length; o++) s = i[o], 
            s.__resetExpectations();
            return this._runtimeContext._liveActors = null, Promise.resolve(c);
        },
        skipTestStep: function(e) {
            return e.log.result("skip"), Promise.resolve(!0);
        },
        runTestCasePermutation: function(e) {
            var n = this;
            return new Promise(function(r, o) {
                function s(t) {
                    if (t || (u = !1), c >= i.__steps.length) return n._runtimeContext.popLogger(i._log), 
                    n._superDebug && n._superDebug("========= Done Case: " + e.desc + "\n"), i._log.result(u ? "pass" : "fail"), 
                    i._log.run_end(), e.log.result(u ? "pass" : "fail"), e.log.run_end(), r(u), void 0;
                    var o = i.__steps[c++], a = u || "cleanup" === o.kind;
                    a ? n.runTestStep(o).then(s) : n.skipTestStep(o).then(s);
                }
                n._superDebug && n._superDebug("========= Begin Case: " + e.desc + "\n"), e.log.run_begin();
                var i = new t.TestContext(e, 0);
                this._exposeToTestOptions && this._exposeToTestOptions.variant && (e.log.variant(this._exposeToTestOptions.variant), 
                i.setPermutationVariant(this._exposeToTestOptions.variant)), i._log.run_begin(), 
                n._runtimeContext.pushLogger(i._log);
                var a = i._log.setupFunc({}, e.setupFunc, i, n._runtimeContext);
                a instanceof Error && (n._superDebug && n._superDebug(" :( setup func error thrown!"), 
                i._log.result("fail"), e.log.result("fail"), o(!1)), i.__postSetupFunc();
                var u = !0, c = 0;
                s(!0);
            }.bind(this));
        },
        runTestCase: function(e) {
            return this._runtimeContext = new s(this._exposeToTestOptions, this._fileBlackboard), 
            this._markDefinerUnderTest(this._testDefiner), this.runTestCasePermutation(e, 0);
        },
        _markDefinerUnderTest: function(e) {
            e._runtimeContext = this._runtimeContext;
            for (var t = 0; t < e.__logfabs.length; t++) e.__logfabs[t]._underTest = this._runtimeContext;
        },
        _clearDefinerUnderTest: function(e) {
            e._runtimeContext = null;
            for (var t = 0; t < e.__logfabs.length; t++) e.__logfabs[t]._underTest = null;
        },
        runAll: function(t, n) {
            function r() {
                if (a >= u.__testCases.length) return t.removeListener("exit", o), t.removeListener("uncaughtException", s), 
                u._log.run_end(), c._clearDefinerUnderTest(u), e.clearActiveDeferreds(), i.resolve(c), 
                void 0;
                var n = u.__testCases[a++];
                c.runTestCase(n).then(r);
            }
            function o() {
                console.error("IMMINENT EVENT LOOP TERMINATION IMPLYING BAD TEST, DUMPING LOG."), 
                c.reportResults();
            }
            function s(e) {
                c._logBadThingsToLogger && c._logBadThingsToLogger.uncaughtException(e);
            }
            n && (l = n);
            var i = new e("TestDefinerRunner.runAll"), a = 0, u = this._testDefiner, c = this;
            return u._log.run_begin(), t.once("exit", o), t.on("uncaughtException", s), e.setUnhandledRejectionHandler(s), 
            r(), i.promise;
        },
        reportResults: function() {
            var e, n, r = this._testDefiner, o = {};
            n = t.LOGFAB._rawDefs;
            for (e in n) o[e] = n[e];
            n = t.__LAZYLOGFAB._rawDefs;
            for (e in n) o[e] = n[e];
            for (var s = 0; s < r.__logfabs.length; s++) {
                n = r.__logfabs[s]._rawDefs;
                for (e in n) o[e] = n[e];
            }
            var i = {
                schema: o,
                log: r._log
            };
            this._resultsReporter(i);
        }
    }, o.runTestsFromModule = function(t, n, o, s) {
        function a() {
            s && s('All tests in "' + t + '" run, ' + "generating results."), g.reportResults(), 
            d.resolve(!0);
        }
        var g, d = new e("runTestsFromModule:" + t), f = n.resultsReporter || c(o.reliableOutput), p = null;
        n && n.variant && (p = n.variant);
        var _ = !1;
        return o.callbackOnError(function(e, n) {
            _ || (u(t, n, p, [ e ], f), d.resolve(!0), _ = !0);
        }), r([ t ], function(e) {
            var r = o.gobbleAndStopTrappingErrors();
            if (!_) {
                if (r.length) return u(t, "", p, r, f), d.resolve(!0), void 0;
                if (!e.TD) {
                    var c = new Error("Test module: '" + t + "' does not export a 'TD' symbol!");
                    return u(t, t, p, [ c ], f), d.resolve(!0), void 0;
                }
                n.hasOwnProperty("defaultStepDuration") && (l = n.defaultStepDuration), g = new i(e.TD, s, n.exposeToTest, f), 
                g.runAll(o).then(a, a);
            }
        }), d.promise;
    };
});